<template>
  <div :class="{ 'file-upload': true }">
    <div v-if="error" class="error-container">
      <error-view :error="error" />
      <button class="button cancel" @click.stop.prevent="cancel">Cancel</button>
    </div>
    <div v-else-if="preview" class="preview-container">
      <h4 v-if="typeof preview == 'string'">{{ preview }}</h4>
      <img class="preview" v-else-if="preview" :src="preview" />

      <div v-if="!done && !sending" class="buttons">
        <button class="button" @click="confirm">Confirm</button>
        <button class="button cancel" secondary @click="cancel">Cancel</button>
      </div>
      <div v-else-if="!done && sending" class="progress">
        <div class="bar" :style="{ width: `${percentUploaded}%` }">
          {{ percentUploaded }}%
        </div>
      </div>
    </div>

    <div v-if="!file && !error" class="field-container">
      <h5 class="prompt" v-if="!file"><slot>Drag file here to upload</slot></h5>
      <input
        class="file-input"
        v-if="!file && !error"
        ref="input"
        :key="`i-${key}`"
        type="file"
        @input="inputted"
      />
    </div>
  </div>
</template>
<style lang="scss">
@import "~assets/mixins.scss";
.field-container {
  display: flex;
  flex-direction: column;
  align-items: center;
  justify-content: center;
  flex-grow: 1;
}

.file-upload {
  display: flex;
  flex-direction: column;
  align-items: center;
  justify-content: center;
  flex-grow: 1;
  position: relative;
  border: 1px dotted white;
  min-height: $grid * 2;

  .label {
    color: #7e7e91;
    margin-bottom: $grid * 0.72;
    max-width: 50%;
    text-align: center;
  }
  .prompt {
    margin: 0;
    color: white;
    text-align: center;
  }

  .file-input {
    opacity: 0;

    left: 0;
    right: 0;
    top: 0;
    bottom: 0;

    position: absolute;

    width: 100%;
    height: 100%;
  }

  &.over {
    background: gray;
  }

  .preview-container {
    text-align: center;

    position: absolute;

    top: 0;
    left: 0;
    right: 0;
    bottom: 0;

    .progress {
      position: absolute;
      bottom: 0;
      left: 0;
      right: 0;
      height: $grid;

      .bar {
        position: absolute;

        background-color: blue;
        opacity: 0.8;

        top: 0;
        left: 0;
        bottom: 0;

        min-width: $grid;
      }
    }

    .error-container {
      display: flex;
      flex-direction: column;
      justify-content: center;
      align-items: center;

      position: absolute;
      top: 0;
      bottom: 0;
      right: 0;
      left: 0;
    }

    .buttons {
      position: absolute;

      display: flex;
      flex-direction: row;
      justify-content: center;

      bottom: 20%;
      width: 100%;
    }

    .cancel {
      background-color: white;
      color: black;
    }
  }

  .preview {
    max-width: 100%;
    min-width: 50%;
    min-height: 50%;
    max-height: 100%;
    margin: auto;
  }
}
</style>
<script>
import uuid from "uuid/v4";
import net from "unet";

export default {
  components: {},
  props: {
    name: {
      type: String,
      required: false,
      default: "file",
    },
    endpoint: {
      type: String,
      required: true,
    },
  },
  mixins: [],
  data() {
    return {
      key: +new Date(),
      error: null,
      percentUploaded: null,
      file: null,
      sending: false,
      preview: null,
      done: false,
    };
  },
  computed: {},
  watch: {},
  mounted() {
    // start polling the input to see when it changes
    this._interval = this._interval || setInterval(this.checkField, 100);
  },
  beforeDestroy() {
    if (this._interval) {
      clearInterval(this._interval);
    }
  },
  methods: {
    confirm() {
      this.send();
    },
    cancel() {
      this.key = +new Date();
      this.preview = null;
      this.file = null;
      this.error = null;
      this.done = false;
      this.percentUploaded = null;
    },
    checkField() {
      if (!this.$refs.input) return;
      if (this.$refs.input.test_file) return this.inputted();
      if (this.$refs.input.files.length == 0) return;
      if (this.$refs.input.files[0] != this._file) this.inputted();
    },
    async inputted() {
      try {
        // for dirty checking:
        this.file = this.$refs.input.test_file || this.$refs.input.files[0];
        this.preview = this.file.name;
      } catch (x) {
        this.error = x;
        this.preview = null;
        this.file = null;
        return;
      }
    },
    async send() {
      if (!this.file) throw new Error("No file to send");

      var fd = new FormData();
      fd.append(this.name, this.file, this.file.name);

      this.sending = true;

      var { response, result, error } = await net({
        method: "POST",
        url: this.endpoint,
        body: fd,
        onUploadProgress: (percentage, event) => {
          console.log("progress: ", percentage);
          // var percentage = 100*(event.loaded / event.total);
          // console.log("PROGRESS: ",percentage);
          this.percentUploaded = Math.floor(percentage);
        },
      });

      this.sending = false;
      this.done = true;

      if (result) {
        this.$emit("input", result);
      } else if (error) {
        this.error = error;
        // this.$emit('error',error);
      } else {
        this.$report(response);
      }
    },
  },
};
</script>
